Tool: list_data_sources
List all the data sources that the project has access to.
The following example shows a MCP call to list all data sources in the project myproject in the location myregion.
If the location isn't explicitly specified, and it can't be determined from the resources in the request, then the default location is used. If the default location isn't set, then the job runs in the US multi-region.
list_data_sources(project_id="myproject", location="myregion")
The following sample demonstrate how to use curl to invoke the list_data_sources MCP tool.
| Curl Request |
|---|
curl --location 'https://bigquerydatatransfer.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "list_data_sources", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' |
Input Schema
Request for listing data sources.
ListDataSourcesRequest
| JSON representation |
|---|
{ "projectId": string } |
| Fields | |
|---|---|
projectId |
Required. Project ID or project number. |
Output Schema
Response for listing data sources.
ListDataSourcesResponse
| JSON representation |
|---|
{
"dataSources": [
{
object ( |
| Fields | |
|---|---|
dataSources[] |
Data sources. |
DataSource
| JSON representation |
|---|
{ "name": string, "dataSourceId": string, "displayName": string, "description": string, "clientId": string, "scopes": [ string ], "transferType": enum ( |
| Fields | |
|---|---|
name |
Output only. Data source resource name. |
dataSourceId |
Data source id. |
displayName |
User friendly data source name. |
description |
User friendly data source description string. |
clientId |
Data source client id which should be used to receive refresh token. |
scopes[] |
Api auth scopes for which refresh token needs to be obtained. These are scopes needed by a data source to prepare data and ingest them into BigQuery, e.g., https://www.googleapis.com/auth/bigquery |
transferType |
Deprecated. This field has no effect. |
supportsMultipleTransfers |
Deprecated. This field has no effect. |
updateDeadlineSeconds |
The number of seconds to wait for an update from the data source before the Data Transfer Service marks the transfer as FAILED. |
defaultSchedule |
Default data transfer schedule. Examples of valid schedules include: |
supportsCustomSchedule |
Specifies whether the data source supports a user defined schedule, or operates on the default schedule. When set to |
parameters[] |
Data source parameters. |
helpUrl |
Url for the help document for this data source. |
authorizationType |
Indicates the type of authorization. |
dataRefreshType |
Specifies whether the data source supports automatic data refresh for the past few days, and how it's supported. For some data sources, data might not be complete until a few days later, so it's useful to refresh data automatically. |
defaultDataRefreshWindowDays |
Default data refresh window on days. Only meaningful when |
manualRunsDisabled |
Disables backfilling and manual run scheduling for the data source. |
minimumScheduleInterval |
The minimum interval for scheduler to schedule runs. A duration in seconds with up to nine fractional digits, ending with ' |
DataSourceParameter
| JSON representation |
|---|
{ "paramId": string, "displayName": string, "description": string, "type": enum ( |
| Fields | |
|---|---|
paramId |
Parameter identifier. |
displayName |
Parameter display name in the user interface. |
description |
Parameter description. |
type |
Parameter type. |
required |
Is parameter required. |
repeated |
Deprecated. This field has no effect. |
validationRegex |
Regular expression which can be used for parameter validation. |
allowedValues[] |
All possible values for the parameter. |
minValue |
For integer and double values specifies minimum allowed value. |
maxValue |
For integer and double values specifies maximum allowed value. |
fields[] |
Deprecated. This field has no effect. |
validationDescription |
Description of the requirements for this field, in case the user input does not fulfill the regex pattern or min/max values. |
validationHelpUrl |
URL to a help document to further explain the naming requirements. |
immutable |
Cannot be changed after initial creation. |
recurse |
Deprecated. This field has no effect. |
deprecated |
If true, it should not be used in new transfers, and it should not be visible to users. |
Union field
|
|
maxListSize |
For list parameters, the max size of the list. |
DoubleValue
| JSON representation |
|---|
{ "value": number } |
| Fields | |
|---|---|
value |
The double value. |
Duration
| JSON representation |
|---|
{ "seconds": string, "nanos": integer } |
| Fields | |
|---|---|
seconds |
Signed seconds of the span of time. Must be from -315,576,000,000 to +315,576,000,000 inclusive. Note: these bounds are computed from: 60 sec/min * 60 min/hr * 24 hr/day * 365.25 days/year * 10000 years |
nanos |
Signed fractions of a second at nanosecond resolution of the span of time. Durations less than one second are represented with a 0 |
Tool Annotations
Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ❌